#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(MongoConnect)
    CONCEPT_FUNCTION(MongoConnectReplica)
    CONCEPT_FUNCTION(MongoDisconnect)
    CONCEPT_FUNCTION(MongoError)
    CONCEPT_FUNCTION(MongoSetOpTimeout)
    CONCEPT_FUNCTION(MongoCheckConnection)

    CONCEPT_FUNCTION(MongoAddUser)
    CONCEPT_FUNCTION(MongoAuthenticate)
    CONCEPT_FUNCTION(MongoDropDb)
    CONCEPT_FUNCTION(MongoDropCollection)

    CONCEPT_FUNCTION(MongoInsert)
    CONCEPT_FUNCTION(MongoUpdate)
    CONCEPT_FUNCTION(MongoUpdateType)
    CONCEPT_FUNCTION(MongoUpdateObject)
    CONCEPT_FUNCTION(MongoRemove)

    CONCEPT_FUNCTION(MongoCount)
    CONCEPT_FUNCTION(MongoFind)
    CONCEPT_FUNCTION(MongoNext)
    CONCEPT_FUNCTION(MongoClose)
    CONCEPT_FUNCTION(MongoData)

    CONCEPT_FUNCTION(MongoFindOne)

    CONCEPT_FUNCTION(MongoIsMaster)
    CONCEPT_FUNCTION(MongoLastError)
    CONCEPT_FUNCTION(MongoPrevError)

    CONCEPT_FUNCTION(MongoSimpleCommand)
    CONCEPT_FUNCTION(MongoCommand)

    CONCEPT_FUNCTION(MongoSimpleIndex)
    CONCEPT_FUNCTION(MongoIndex)

    CONCEPT_FUNCTION(GridFSInit)
    CONCEPT_FUNCTION(GridFSDone)
    CONCEPT_FUNCTION(GridFSStore)
    CONCEPT_FUNCTION(GridFSGet)
    CONCEPT_FUNCTION(GridFSRemove)
    CONCEPT_FUNCTION(GridFSExists)
    CONCEPT_FUNCTION(GridFSSize)
    CONCEPT_FUNCTION(GridFSType)
    CONCEPT_FUNCTION(GridFSDate)
    CONCEPT_FUNCTION(GridFSMD5)
}


#endif // __LIBRARY_H
