#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...
#define _USE_SECONDARY_AES

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    // other functions declared here
    CONCEPT_FUNCTION(MD5Init)
    CONCEPT_FUNCTION(MD5Update)
    CONCEPT_FUNCTION(MD5Final)

    CONCEPT_FUNCTION(SHA1Init)
    CONCEPT_FUNCTION(SHA1Update)
    CONCEPT_FUNCTION(SHA1Final)

    CONCEPT_FUNCTION(SHA256Init)
    CONCEPT_FUNCTION(SHA256Update)
    CONCEPT_FUNCTION(SHA256Final)

    CONCEPT_DLL_API CONCEPT_md5 CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT_sha1 CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT_sha256 CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT_crc32 CONCEPT_API_PARAMETERS;

    CONCEPT_FUNCTION(AESEncryptInit)
    CONCEPT_FUNCTION(AESDecryptInit)
    CONCEPT_FUNCTION(AESRelease)
    CONCEPT_FUNCTION(AESEncrypt)
    CONCEPT_FUNCTION(AESDecrypt)

    CONCEPT_FUNCTION(aes_encrypt)
    CONCEPT_FUNCTION(aes_decrypt)

    CONCEPT_DLL_API CONCEPT__rsa_encrypt CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT__rsa_decrypt CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT__rsa_generate_keys CONCEPT_API_PARAMETERS;

    CONCEPT_DLL_API CONCEPT__rsa_sign CONCEPT_API_PARAMETERS;
    CONCEPT_DLL_API CONCEPT__rsa_verify CONCEPT_API_PARAMETERS;

    CONCEPT_FUNCTION(hmac_md5)
    CONCEPT_FUNCTION(hmac_sha1)
    CONCEPT_FUNCTION(hmac_sha256)

    CONCEPT_FUNCTION(Murmur)

    CONCEPT_FUNCTION(DRMKey)
    CONCEPT_FUNCTION(PBKDF2)
#ifdef _USE_SECONDARY_AES
    CONCEPT_FUNCTION(AesDone)
    CONCEPT_FUNCTION(AesSetKey)
    CONCEPT_FUNCTION(AesSetInitVector)
    CONCEPT_FUNCTION(AesSetFeedbackSize)
    CONCEPT_FUNCTION(AesEncryptECB)
    CONCEPT_FUNCTION(AesEncryptCBC)
    CONCEPT_FUNCTION(AesEncryptPCBC)
    CONCEPT_FUNCTION(AesEncryptCRT)
    CONCEPT_FUNCTION(AesEncryptOFB)
    CONCEPT_FUNCTION(AesEncryptCFB)
    CONCEPT_FUNCTION(AesDecryptECB)
    CONCEPT_FUNCTION(AesDecryptCBC)
    CONCEPT_FUNCTION(AesDecryptPCBC)
    CONCEPT_FUNCTION(AesDecryptCRT)
    CONCEPT_FUNCTION(AesDecryptOFB)
    CONCEPT_FUNCTION(AesDecryptCFB)
#endif
}


#endif // __LIBRARY_H
