#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(RTPCreate)
    CONCEPT_FUNCTION(RTPError)
    CONCEPT_FUNCTION(RTPBYEDestroy)
    CONCEPT_FUNCTION(RTPDestroy)
    CONCEPT_FUNCTION(RTPAddDestination)
    CONCEPT_FUNCTION(RTPDeleteDestination)
    CONCEPT_FUNCTION(RTPClearDestinations)

    CONCEPT_FUNCTION(RTPSend)

    CONCEPT_FUNCTION(RTPBeginDataAccess)
    CONCEPT_FUNCTION(RTPEndDataAccess)

    CONCEPT_FUNCTION(RTPGetNextPacket)

    CONCEPT_FUNCTION(RTPGotoFirstSourceWithData)
    CONCEPT_FUNCTION(RTPGotoNextSourceWithData)
    CONCEPT_FUNCTION(RTPGotoPreviousSourceWithData)
    CONCEPT_FUNCTION(RTPGetCurrentSourceInfo)
    CONCEPT_FUNCTION(RTPCurrentSourceReceivedBYE)

    CONCEPT_FUNCTION(RTPPoll)

    CONCEPT_FUNCTION(RTPSetDefaultPayloadType)
    CONCEPT_FUNCTION(RTPSetDefaultMark)
    CONCEPT_FUNCTION(RTPSetDefaultTimestampIncrement)
    CONCEPT_FUNCTION(RTPIncrementTimestamp)
    CONCEPT_FUNCTION(RTPIncrementTimestampDefault)
    CONCEPT_FUNCTION(RTPSetPreTransmissionDelay)
    CONCEPT_FUNCTION(RTPSetReceiveMode)
    CONCEPT_FUNCTION(RTPAddToIgnoreList)
    CONCEPT_FUNCTION(RTPDeleteFromIgnoreList)
    CONCEPT_FUNCTION(RTPClearIgnoreList)
    CONCEPT_FUNCTION(RTPAddToAcceptList)
    CONCEPT_FUNCTION(RTPDeleteFromAcceptList)
    CONCEPT_FUNCTION(RTPSetMaximumPacketSize)
    CONCEPT_FUNCTION(RTPSetSessionBandwidth)
    CONCEPT_FUNCTION(RTPSetTimestampUnit)
    CONCEPT_FUNCTION(RTPSetNameInterval)
    CONCEPT_FUNCTION(RTPSetEMailInterval)
    CONCEPT_FUNCTION(RTPSetLocationInterval)
    CONCEPT_FUNCTION(RTPSetPhoneInterval)
    CONCEPT_FUNCTION(RTPSetToolInterval)
    CONCEPT_FUNCTION(RTPSetNoteInterval)
    CONCEPT_FUNCTION(RTPSetLocalName)
    CONCEPT_FUNCTION(RTPSetLocalEMail)
    CONCEPT_FUNCTION(RTPSetLocalLocation)
    CONCEPT_FUNCTION(RTPSetLocalPhone)
    CONCEPT_FUNCTION(RTPSetLocalTool)
    CONCEPT_FUNCTION(RTPSetLocalNote)

    CONCEPT_FUNCTION(RTPWait)
}
#endif // __LIBRARY_H
