#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(osip_init)
    CONCEPT_FUNCTION(osip_release)
    CONCEPT_FUNCTION(osip_parse)
    CONCEPT_FUNCTION(osip_event_free)
    CONCEPT_FUNCTION(osip_find_transaction_and_add_event)
    CONCEPT_FUNCTION(osip_transaction_add_event)
    CONCEPT_FUNCTION(osip_create_transaction)
    CONCEPT_FUNCTION(osip_transaction_init)
    CONCEPT_FUNCTION(osip_transaction_set_out_socket)
    CONCEPT_FUNCTION(osip_retransmissions_execute)
    CONCEPT_FUNCTION(osip_transaction_execute)
    CONCEPT_FUNCTION(osip_transaction_free)
    CONCEPT_FUNCTION(osip_transaction_free2)
    CONCEPT_FUNCTION(osip_transaction_set_your_instance)
    CONCEPT_FUNCTION(osip_transaction_get_your_instance)
    CONCEPT_FUNCTION(osip_event_describe)
    CONCEPT_FUNCTION(osip_transaction_get_destination)
    CONCEPT_FUNCTION(osip_nict_set_destination)

    CONCEPT_FUNCTION(osip_message_describe)
    CONCEPT_FUNCTION(osip_message_init)
    CONCEPT_FUNCTION(osip_message_free)
    CONCEPT_FUNCTION(osip_message_to_str)
    CONCEPT_FUNCTION(osip_message_parse)
    //CONCEPT_FUNCTION(osip_message_parse_sipfrag)
    //CONCEPT_FUNCTION(osip_message_to_str_sipfrag)
    CONCEPT_FUNCTION(osip_message_clone)
    CONCEPT_FUNCTION(osip_message_set_reason_phrase)
    CONCEPT_FUNCTION(osip_message_get_reason_phrase)
    CONCEPT_FUNCTION(osip_message_set_status_code)
    CONCEPT_FUNCTION(osip_message_get_status_code)
    CONCEPT_FUNCTION(osip_message_set_method)
    CONCEPT_FUNCTION(osip_message_get_method)
    CONCEPT_FUNCTION(osip_message_set_version)
    CONCEPT_FUNCTION(osip_message_get_version)
    CONCEPT_FUNCTION(osip_message_set_uri)
    CONCEPT_FUNCTION(osip_message_get_uri)

    CONCEPT_FUNCTION(osip_message_set_date)
    CONCEPT_FUNCTION(osip_message_get_date)
    CONCEPT_FUNCTION(osip_message_set_encryption)
    CONCEPT_FUNCTION(osip_message_get_encryption)
    CONCEPT_FUNCTION(osip_message_set_organization)
    CONCEPT_FUNCTION(osip_message_get_organization)
    CONCEPT_FUNCTION(osip_message_set_require)
    CONCEPT_FUNCTION(osip_message_get_require)
    CONCEPT_FUNCTION(osip_message_set_supported)
    CONCEPT_FUNCTION(osip_message_get_supported)
    CONCEPT_FUNCTION(osip_message_set_timestamp)
    CONCEPT_FUNCTION(osip_message_get_timestamp)
    CONCEPT_FUNCTION(osip_message_set_user_agent)
    CONCEPT_FUNCTION(osip_message_get_user_agent)
    CONCEPT_FUNCTION(osip_message_set_content_language)
    CONCEPT_FUNCTION(osip_message_get_content_language)
    CONCEPT_FUNCTION(osip_message_set_expires)
    CONCEPT_FUNCTION(osip_message_get_expires)
    CONCEPT_FUNCTION(osip_message_set_in_reply_to)
    CONCEPT_FUNCTION(osip_message_get_in_reply_to)
    CONCEPT_FUNCTION(osip_message_set_max_forwards)
    CONCEPT_FUNCTION(osip_message_get_max_forwards)
    CONCEPT_FUNCTION(osip_message_set_priority)
    CONCEPT_FUNCTION(osip_message_get_priority)
    CONCEPT_FUNCTION(osip_message_set_proxy_require)
    CONCEPT_FUNCTION(osip_message_get_proxy_require)
    CONCEPT_FUNCTION(osip_message_set_response_key)
    CONCEPT_FUNCTION(osip_message_get_response_key)
    CONCEPT_FUNCTION(osip_message_set_subject)
    CONCEPT_FUNCTION(osip_message_get_subject)
    CONCEPT_FUNCTION(osip_message_set_retry_after)
    CONCEPT_FUNCTION(osip_message_get_retry_after)
    CONCEPT_FUNCTION(osip_message_set_server)
    CONCEPT_FUNCTION(osip_message_get_server)
    CONCEPT_FUNCTION(osip_message_set_unsupported)
    CONCEPT_FUNCTION(osip_message_get_unsupported)
    CONCEPT_FUNCTION(osip_message_set_warning)
    CONCEPT_FUNCTION(osip_message_get_warning)
    CONCEPT_FUNCTION(osip_message_fix_last_via_header)
    CONCEPT_FUNCTION(osip_message_get__property)
    CONCEPT_FUNCTION(osip_message_force_update)
    CONCEPT_FUNCTION(osip_message_get_reason)
    CONCEPT_FUNCTION(osip_message_set_accept)
    CONCEPT_FUNCTION(osip_message_get_accept)
    CONCEPT_FUNCTION(osip_message_set_accept_encoding)
    CONCEPT_FUNCTION(osip_message_get_accept_encoding)
    CONCEPT_FUNCTION(osip_message_set_accept_language)
    CONCEPT_FUNCTION(osip_message_get_accept_language)
    CONCEPT_FUNCTION(osip_message_set_alert_info)
    CONCEPT_FUNCTION(osip_message_get_alert_info)
    CONCEPT_FUNCTION(osip_message_set_allow)
    CONCEPT_FUNCTION(osip_message_get_allow)
    CONCEPT_FUNCTION(osip_message_set_authentication_info)
    CONCEPT_FUNCTION(osip_message_get_authentication_info)
    CONCEPT_FUNCTION(osip_message_set_authorization)
    CONCEPT_FUNCTION(osip_message_get_authorization)
    CONCEPT_FUNCTION(osip_message_set_call_id)
    CONCEPT_FUNCTION(osip_message_get_call_id)
    CONCEPT_FUNCTION(osip_message_set_call_info)
    CONCEPT_FUNCTION(osip_message_get_call_info)
    CONCEPT_FUNCTION(osip_message_set_contact)
    CONCEPT_FUNCTION(osip_message_get_contact)
    CONCEPT_FUNCTION(osip_message_set_content_encoding)
    CONCEPT_FUNCTION(osip_message_get_content_encoding)
    CONCEPT_FUNCTION(osip_message_set_content_length)
    CONCEPT_FUNCTION(osip_message_get_content_length)
    CONCEPT_FUNCTION(osip_message_set_content_type)
    CONCEPT_FUNCTION(osip_message_get_content_type)
    CONCEPT_FUNCTION(osip_message_set_cseq)
    CONCEPT_FUNCTION(osip_message_get_cseq)
    CONCEPT_FUNCTION(osip_message_set_error_info)
    CONCEPT_FUNCTION(osip_message_get_error_info)
    CONCEPT_FUNCTION(osip_message_set_from)
    CONCEPT_FUNCTION(osip_message_get_from)
    CONCEPT_FUNCTION(osip_message_set_mime_version)
    CONCEPT_FUNCTION(osip_message_get_mime_version)
    CONCEPT_FUNCTION(osip_message_set_proxy_authenticate)
    CONCEPT_FUNCTION(osip_message_get_proxy_authenticate)
    CONCEPT_FUNCTION(osip_message_set_proxy_authorization)
    CONCEPT_FUNCTION(osip_message_get_proxy_authorization)
    CONCEPT_FUNCTION(osip_message_set_proxy_authentication_info)
    CONCEPT_FUNCTION(osip_message_get_proxy_authentication_info)
    CONCEPT_FUNCTION(osip_message_set_record_route)
    CONCEPT_FUNCTION(osip_message_get_record_route)
    CONCEPT_FUNCTION(osip_message_set_route)
    CONCEPT_FUNCTION(osip_message_get_route)
    CONCEPT_FUNCTION(osip_message_set_to)
    CONCEPT_FUNCTION(osip_message_get_to)
    CONCEPT_FUNCTION(osip_message_set_via)
    //CONCEPT_FUNCTION(osip_message_append_via)
    CONCEPT_FUNCTION(osip_message_get_via)
    CONCEPT_FUNCTION(osip_message_set_www_authenticate)
    CONCEPT_FUNCTION(osip_message_get_www_authenticate)
    CONCEPT_FUNCTION(osip_message_set_header)
    //CONCEPT_FUNCTION(osip_message_replace_header)
    CONCEPT_FUNCTION(osip_message_set_topheader)
    CONCEPT_FUNCTION(osip_message_header_get_byname)
    CONCEPT_FUNCTION(osip_message_get_header)
    CONCEPT_FUNCTION(osip_message_set_body)
    CONCEPT_FUNCTION(osip_message_set_body_mime)
    CONCEPT_FUNCTION(osip_message_get_body)

    CONCEPT_FUNCTION(osip_via_init)
    CONCEPT_FUNCTION(osip_via_free)
    CONCEPT_FUNCTION(osip_via_parse)
    CONCEPT_FUNCTION(osip_via_to_str)
    CONCEPT_FUNCTION(osip_via_clone)
    CONCEPT_FUNCTION(via_set_version)
    CONCEPT_FUNCTION(via_get_version)
    CONCEPT_FUNCTION(via_set_protocol)
    CONCEPT_FUNCTION(via_get_protocol)
    CONCEPT_FUNCTION(via_set_host)
    CONCEPT_FUNCTION(via_get_host)
    CONCEPT_FUNCTION(via_set_port)
    CONCEPT_FUNCTION(via_get_port)
    CONCEPT_FUNCTION(via_set_comment)
    CONCEPT_FUNCTION(via_get_comment)
    CONCEPT_FUNCTION(osip_via_set_ttl)
    CONCEPT_FUNCTION(osip_via_set_maddr)
    CONCEPT_FUNCTION(osip_via_set_received)
    CONCEPT_FUNCTION(osip_via_set_branch)
    CONCEPT_FUNCTION(osip_via_param_add)
    CONCEPT_FUNCTION(osip_via_match)

    CONCEPT_FUNCTION(osip_uri_init)
    CONCEPT_FUNCTION(osip_uri_free)
    CONCEPT_FUNCTION(osip_uri_parse)
    CONCEPT_FUNCTION(osip_uri_to_str)
    CONCEPT_FUNCTION(osip_uri_clone)
    CONCEPT_FUNCTION(osip_uri_set_scheme)
    CONCEPT_FUNCTION(osip_uri_get_scheme)
    CONCEPT_FUNCTION(osip_uri_set_host)
    CONCEPT_FUNCTION(osip_uri_get_host)
    CONCEPT_FUNCTION(osip_uri_set_username)
    CONCEPT_FUNCTION(osip_uri_get_username)
    CONCEPT_FUNCTION(osip_uri_set_password)
    CONCEPT_FUNCTION(osip_uri_get_password)
    CONCEPT_FUNCTION(osip_uri_set_port)
    CONCEPT_FUNCTION(osip_uri_get_port)

    CONCEPT_FUNCTION(osip_uri_set_transport_udp)
    CONCEPT_FUNCTION(osip_uri_set_transport_tcp)
    CONCEPT_FUNCTION(osip_uri_set_transport_sctp)
    CONCEPT_FUNCTION(osip_uri_set_transport_tls)

    CONCEPT_FUNCTION(osip_ict_execute)
    CONCEPT_FUNCTION(osip_ist_execute)
    CONCEPT_FUNCTION(osip_nict_execute)
    CONCEPT_FUNCTION(osip_nist_execute)
    CONCEPT_FUNCTION(osip_timers_ict_execute)
    CONCEPT_FUNCTION(osip_timers_ist_execute)
    CONCEPT_FUNCTION(osip_timers_nict_execute)
    CONCEPT_FUNCTION(osip_timers_nist_execute)

    CONCEPT_FUNCTION(osip_set_cb_send_message)
    CONCEPT_FUNCTION(osip_set_message_callback)
    CONCEPT_FUNCTION(osip_set_kill_transaction_callback)
    CONCEPT_FUNCTION(osip_set_transport_error_callback)

    CONCEPT_FUNCTION(osip_list_add)
    CONCEPT_FUNCTION(osip_list_add_string)
    CONCEPT_FUNCTION(osip_list_size)
    CONCEPT_FUNCTION(osip_list_remove)
    CONCEPT_FUNCTION(osip_list_eol)
    CONCEPT_FUNCTION(osip_list_get)

    CONCEPT_FUNCTION(osip_from_message)
    CONCEPT_FUNCTION(osip_from_init)
    CONCEPT_FUNCTION(osip_from_free)
    CONCEPT_FUNCTION(osip_from_parse)
    CONCEPT_FUNCTION(osip_from_to_str)
    CONCEPT_FUNCTION(osip_from_clone)
    CONCEPT_FUNCTION(osip_from_set_displayname)
    CONCEPT_FUNCTION(osip_from_get_displayname)
    CONCEPT_FUNCTION(osip_from_set_url)
    CONCEPT_FUNCTION(osip_from_get_url)
    CONCEPT_FUNCTION(osip_from_get_tag)
    CONCEPT_FUNCTION(osip_from_set_tag)
    CONCEPT_FUNCTION(osip_from_compare)
    CONCEPT_FUNCTION(osip_from_tag_match)

    CONCEPT_FUNCTION(osip_to_message)
    CONCEPT_FUNCTION(osip_to_init)
    CONCEPT_FUNCTION(osip_to_free)
    CONCEPT_FUNCTION(osip_to_parse)
    CONCEPT_FUNCTION(osip_to_to_str)
    CONCEPT_FUNCTION(osip_to_clone)
    CONCEPT_FUNCTION(osip_to_set_displayname)
    CONCEPT_FUNCTION(osip_to_get_displayname)
    CONCEPT_FUNCTION(osip_to_set_url)
    CONCEPT_FUNCTION(osip_to_get_url)
    CONCEPT_FUNCTION(osip_to_get_tag)
    CONCEPT_FUNCTION(osip_to_set_tag)
    CONCEPT_FUNCTION(osip_to_compare)
    CONCEPT_FUNCTION(osip_to_tag_match)

    CONCEPT_FUNCTION(osip_call_id_init)
    CONCEPT_FUNCTION(osip_call_id_free)
    CONCEPT_FUNCTION(osip_call_id_parse)
    CONCEPT_FUNCTION(osip_call_id_clone)
    CONCEPT_FUNCTION(osip_call_id_match)
    CONCEPT_FUNCTION(osip_call_id_to_str)

    CONCEPT_FUNCTION(osip_call_info_init)
    CONCEPT_FUNCTION(osip_call_info_free)
    CONCEPT_FUNCTION(osip_call_info_parse)
    CONCEPT_FUNCTION(osip_call_info_clone)

    CONCEPT_FUNCTION(osip_accept_free)
    CONCEPT_FUNCTION(osip_accept_parse)
    CONCEPT_FUNCTION(osip_accept_clone)

    CONCEPT_FUNCTION(osip_accept_encoding_init)
    CONCEPT_FUNCTION(osip_accept_encoding_free)
    CONCEPT_FUNCTION(osip_accept_encoding_parse)
    CONCEPT_FUNCTION(osip_accept_encoding_clone)

    CONCEPT_FUNCTION(osip_accept_language_init)
    CONCEPT_FUNCTION(osip_accept_language_free)
    CONCEPT_FUNCTION(osip_accept_language_parse)
    CONCEPT_FUNCTION(osip_accept_language_clone)

    CONCEPT_FUNCTION(osip_alert_info_init)
    CONCEPT_FUNCTION(osip_alert_info_free)
    CONCEPT_FUNCTION(osip_alert_info_parse)
    CONCEPT_FUNCTION(osip_alert_info_clone)

    CONCEPT_FUNCTION(osip_allow_init)
    CONCEPT_FUNCTION(osip_allow_free)
    CONCEPT_FUNCTION(osip_allow_parse)
    CONCEPT_FUNCTION(osip_allow_clone)

    CONCEPT_FUNCTION(osip_authentication_info_init)
    CONCEPT_FUNCTION(osip_authentication_info_free)
    CONCEPT_FUNCTION(osip_authentication_info_parse)
    CONCEPT_FUNCTION(osip_authentication_info_clone)

    CONCEPT_FUNCTION(osip_authorization_init)
    CONCEPT_FUNCTION(osip_authorization_free)
    CONCEPT_FUNCTION(osip_authorization_parse)
    CONCEPT_FUNCTION(osip_authorization_clone)

    CONCEPT_FUNCTION(osip_contact_init)
    CONCEPT_FUNCTION(osip_contact_free)
    CONCEPT_FUNCTION(osip_contact_parse)
    CONCEPT_FUNCTION(osip_contact_clone)

    CONCEPT_FUNCTION(osip_content_disposition_init)
    CONCEPT_FUNCTION(osip_content_disposition_free)
    CONCEPT_FUNCTION(osip_content_disposition_parse)
    CONCEPT_FUNCTION(osip_content_disposition_clone)

    CONCEPT_FUNCTION(osip_content_encoding_init)
    CONCEPT_FUNCTION(osip_content_encoding_free)
    CONCEPT_FUNCTION(osip_content_encoding_parse)
    CONCEPT_FUNCTION(osip_content_encoding_clone)

    CONCEPT_FUNCTION(osip_content_length_init)
    CONCEPT_FUNCTION(osip_content_length_free)
    CONCEPT_FUNCTION(osip_content_length_parse)
    CONCEPT_FUNCTION(osip_content_length_clone)

    CONCEPT_FUNCTION(osip_content_type_init)
    CONCEPT_FUNCTION(osip_content_type_free)
    CONCEPT_FUNCTION(osip_content_type_parse)
    CONCEPT_FUNCTION(osip_content_type_clone)

    CONCEPT_FUNCTION(osip_cseq_init)
    CONCEPT_FUNCTION(osip_cseq_to_str)
    CONCEPT_FUNCTION(osip_cseq_free)
    CONCEPT_FUNCTION(osip_cseq_parse)
    CONCEPT_FUNCTION(osip_cseq_clone)
    CONCEPT_FUNCTION(osip_cseq_match)

    CONCEPT_FUNCTION(osip_error_info_init)
    CONCEPT_FUNCTION(osip_error_info_free)
    CONCEPT_FUNCTION(osip_error_info_parse)
    CONCEPT_FUNCTION(osip_error_info_clone)

    CONCEPT_FUNCTION(osip_header_init)
    CONCEPT_FUNCTION(osip_header_free)
    CONCEPT_FUNCTION(osip_header_clone)

    CONCEPT_FUNCTION(osip_mime_version_init)
    CONCEPT_FUNCTION(osip_mime_version_free)
    CONCEPT_FUNCTION(osip_mime_version_parse)
    CONCEPT_FUNCTION(osip_mime_version_clone)

    CONCEPT_FUNCTION(osip_proxy_authenticate_init)
    CONCEPT_FUNCTION(osip_proxy_authenticate_free)
    CONCEPT_FUNCTION(osip_proxy_authenticate_parse)
    CONCEPT_FUNCTION(osip_proxy_authenticate_clone)

    CONCEPT_FUNCTION(osip_proxy_authentication_info_init)
    CONCEPT_FUNCTION(osip_proxy_authentication_info_free)
    CONCEPT_FUNCTION(osip_proxy_authentication_info_parse)
    CONCEPT_FUNCTION(osip_proxy_authentication_info_clone)

    CONCEPT_FUNCTION(osip_proxy_authorization_init)
    CONCEPT_FUNCTION(osip_proxy_authorization_free)
    CONCEPT_FUNCTION(osip_proxy_authorization_parse)
    CONCEPT_FUNCTION(osip_proxy_authorization_clone)

    CONCEPT_FUNCTION(osip_record_route_init)
    CONCEPT_FUNCTION(osip_record_route_free)
    CONCEPT_FUNCTION(osip_record_route_parse)
    CONCEPT_FUNCTION(osip_record_route_clone)

    CONCEPT_FUNCTION(osip_route_init)
    CONCEPT_FUNCTION(osip_route_free)
    CONCEPT_FUNCTION(osip_route_parse)
    CONCEPT_FUNCTION(osip_route_clone)

    CONCEPT_FUNCTION(osip_www_authenticate_init)
    CONCEPT_FUNCTION(osip_www_authenticate_free)
    CONCEPT_FUNCTION(osip_www_authenticate_parse)
    CONCEPT_FUNCTION(osip_www_authenticate_clone)

    CONCEPT_FUNCTION(sdp_message_init)
    CONCEPT_FUNCTION(sdp_message_free)
    CONCEPT_FUNCTION(sdp_message_parse)
    CONCEPT_FUNCTION(sdp_message_clone)
    CONCEPT_FUNCTION(sdp_message_to_str)

    CONCEPT_FUNCTION(osip_call_id_set_host)
    CONCEPT_FUNCTION(osip_call_id_set_number)
    CONCEPT_FUNCTION(osip_call_id_get_host)
    CONCEPT_FUNCTION(osip_call_id_get_number)

    CONCEPT_FUNCTION(osip_cseq_set_number)
    CONCEPT_FUNCTION(osip_cseq_set_method)
    CONCEPT_FUNCTION(osip_cseq_get_number)
    CONCEPT_FUNCTION(osip_cseq_get_method)

    CONCEPT_FUNCTION(osip_contact_set_displayname)
    CONCEPT_FUNCTION(osip_contact_param_add)

    CONCEPT_FUNCTION(sdp_attribute_init)
    CONCEPT_FUNCTION(sdp_attribute_free)

    CONCEPT_FUNCTION(sdp_connection_init)
    CONCEPT_FUNCTION(sdp_connection_free)

    CONCEPT_FUNCTION(sdp_media_init)
    CONCEPT_FUNCTION(sdp_media_free)

    CONCEPT_FUNCTION(sdp_message_v_version_set)
    CONCEPT_FUNCTION(sdp_message_v_version_get)
    CONCEPT_FUNCTION(sdp_message_o_origin_set)
    CONCEPT_FUNCTION(sdp_message_o_username_get)
    CONCEPT_FUNCTION(sdp_message_o_sess_id_get)
    CONCEPT_FUNCTION(sdp_message_o_sess_version_get)
    CONCEPT_FUNCTION(sdp_message_o_nettype_get)
    CONCEPT_FUNCTION(sdp_message_o_addrtype_get)
    CONCEPT_FUNCTION(sdp_message_o_addr_get)
    CONCEPT_FUNCTION(sdp_message_s_name_set)
    CONCEPT_FUNCTION(sdp_message_s_name_get)
    CONCEPT_FUNCTION(sdp_message_i_info_set)
    CONCEPT_FUNCTION(sdp_message_i_info_get)
    CONCEPT_FUNCTION(sdp_message_u_uri_set)
    CONCEPT_FUNCTION(sdp_message_u_uri_get)
    CONCEPT_FUNCTION(sdp_message_e_email_add)
    CONCEPT_FUNCTION(sdp_message_e_email_get)
    CONCEPT_FUNCTION(sdp_message_p_phone_add)
    CONCEPT_FUNCTION(sdp_message_p_phone_get)
    CONCEPT_FUNCTION(sdp_message_c_connection_add)
    CONCEPT_FUNCTION(sdp_message_c_nettype_get)
    CONCEPT_FUNCTION(sdp_message_c_addrtype_get)
    CONCEPT_FUNCTION(sdp_message_c_addr_get)
    CONCEPT_FUNCTION(sdp_message_c_addr_multicast_ttl_get)
    CONCEPT_FUNCTION(sdp_message_c_addr_multicast_int_get)
    CONCEPT_FUNCTION(sdp_message_b_bandwidth_add)
    CONCEPT_FUNCTION(sdp_message_bandwidth_get)
    CONCEPT_FUNCTION(sdp_message_b_bwtype_get)
    CONCEPT_FUNCTION(sdp_message_b_bandwidth_get)
    CONCEPT_FUNCTION(sdp_message_t_time_descr_add)
    CONCEPT_FUNCTION(sdp_message_t_start_time_get)
    CONCEPT_FUNCTION(sdp_message_t_stop_time_get)
    CONCEPT_FUNCTION(sdp_message_r_repeat_add)
    CONCEPT_FUNCTION(sdp_message_r_repeat_get)
    CONCEPT_FUNCTION(sdp_message_z_adjustments_set)
    CONCEPT_FUNCTION(sdp_message_z_adjustments_get)
    CONCEPT_FUNCTION(sdp_message_k_key_set)
    CONCEPT_FUNCTION(sdp_message_k_keytype_get)
    CONCEPT_FUNCTION(sdp_message_k_keydata_get)
    CONCEPT_FUNCTION(sdp_message_a_attribute_add)
    //CONCEPT_FUNCTION(sdp_message_a_attribute_del)
    //CONCEPT_FUNCTION(sdp_message_a_attribute_del_at_index)
    CONCEPT_FUNCTION(sdp_message_attribute_get)
    CONCEPT_FUNCTION(sdp_message_a_att_field_get)
    CONCEPT_FUNCTION(sdp_message_a_att_value_get)
    CONCEPT_FUNCTION(sdp_message_endof_media)
    CONCEPT_FUNCTION(sdp_message_m_media_add)
    CONCEPT_FUNCTION(sdp_message_m_media_get)
    CONCEPT_FUNCTION(sdp_message_m_port_get)
    //CONCEPT_FUNCTION(sdp_message_m_port_set)
    CONCEPT_FUNCTION(sdp_message_m_number_of_port_get)
    CONCEPT_FUNCTION(sdp_message_m_proto_get)
    CONCEPT_FUNCTION(sdp_message_m_payload_add)
    CONCEPT_FUNCTION(sdp_message_m_payload_get)
    //CONCEPT_FUNCTION(sdp_message_m_payload_del)

    CONCEPT_FUNCTION(sdp_bandwidth_init)
    CONCEPT_FUNCTION(sdp_bandwidth_free)

    CONCEPT_FUNCTION(sdp_message_describe)
    CONCEPT_FUNCTION(sdp_media_describe)
    CONCEPT_FUNCTION(sdp_attribute_describe)
    CONCEPT_FUNCTION(sdp_connection_describe)
    CONCEPT_FUNCTION(sdp_bandwidth_describe)

    CONCEPT_FUNCTION(osip_cseq_message)
    CONCEPT_FUNCTION(osip_call_id_message)

    CONCEPT_FUNCTION(osip_contact_set_url)
    CONCEPT_FUNCTION(osip_contact_get_url)
    CONCEPT_FUNCTION(osip_contact_to_str)

    CONCEPT_FUNCTION(osip_body_init)
    CONCEPT_FUNCTION(osip_body_free)
    CONCEPT_FUNCTION(osip_body_parse)
    CONCEPT_FUNCTION(osip_body_parse_mime)
    CONCEPT_FUNCTION(osip_body_clone)
    CONCEPT_FUNCTION(osip_body_to_str)
    CONCEPT_FUNCTION(osip_body_set_header)
    CONCEPT_FUNCTION(osip_body_set_contenttype)

    CONCEPT_FUNCTION(osip_proxy_authenticate_set_auth_type)
    CONCEPT_FUNCTION(osip_proxy_authenticate_get_auth_type)
    CONCEPT_FUNCTION(osip_proxy_authenticate_set_realm)
    CONCEPT_FUNCTION(osip_proxy_authenticate_get_realm)
    CONCEPT_FUNCTION(osip_proxy_authenticate_set_domain)
    CONCEPT_FUNCTION(osip_proxy_authenticate_get_domain)
    CONCEPT_FUNCTION(osip_proxy_authenticate_set_nonce)
    CONCEPT_FUNCTION(osip_proxy_authenticate_get_nonce)
    CONCEPT_FUNCTION(osip_proxy_authenticate_set_opaque)
    CONCEPT_FUNCTION(osip_proxy_authenticate_get_opaque)
    CONCEPT_FUNCTION(osip_proxy_authenticate_set_stale)
    CONCEPT_FUNCTION(osip_proxy_authenticate_get_stale)
    CONCEPT_FUNCTION(osip_proxy_authenticate_set_algorithm)
    CONCEPT_FUNCTION(osip_proxy_authenticate_get_algorithm)
    CONCEPT_FUNCTION(osip_proxy_authenticate_set_qop_options)
    CONCEPT_FUNCTION(osip_proxy_authenticate_get_qop_options)

    CONCEPT_FUNCTION(osip_authorization_set_auth_type)
    CONCEPT_FUNCTION(osip_authorization_get_auth_type)
    CONCEPT_FUNCTION(osip_authorization_set_realm)
    CONCEPT_FUNCTION(osip_authorization_get_realm)
    CONCEPT_FUNCTION(osip_authorization_set_nonce)
    CONCEPT_FUNCTION(osip_authorization_get_nonce)
    CONCEPT_FUNCTION(osip_authorization_set_opaque)
    CONCEPT_FUNCTION(osip_authorization_get_opaque)
    CONCEPT_FUNCTION(osip_authorization_set_algorithm)
    CONCEPT_FUNCTION(osip_authorization_get_algorithm)

    CONCEPT_FUNCTION(osip_authorization_set_username)
    CONCEPT_FUNCTION(osip_authorization_get_username)
    CONCEPT_FUNCTION(osip_authorization_set_uri)
    CONCEPT_FUNCTION(osip_authorization_get_uri)
    CONCEPT_FUNCTION(osip_authorization_set_response)
    CONCEPT_FUNCTION(osip_authorization_get_response)
    CONCEPT_FUNCTION(osip_authorization_set_digest)
    CONCEPT_FUNCTION(osip_authorization_get_digest)
    CONCEPT_FUNCTION(osip_authorization_set_cnonce)
    CONCEPT_FUNCTION(osip_authorization_get_cnonce)
    CONCEPT_FUNCTION(osip_authorization_set_message_qop)
    CONCEPT_FUNCTION(osip_authorization_get_message_qop)
    CONCEPT_FUNCTION(osip_authorization_set_nonce_count)
    CONCEPT_FUNCTION(osip_authorization_get_nonce_count)

    CONCEPT_FUNCTION(osip_authentication_info_set_nextnonce)
    CONCEPT_FUNCTION(osip_authentication_info_get_nextnonce)
    CONCEPT_FUNCTION(osip_authentication_info_set_cnonce)
    CONCEPT_FUNCTION(osip_authentication_info_get_cnonce)
    CONCEPT_FUNCTION(osip_authentication_info_set_qop_options)
    CONCEPT_FUNCTION(osip_authentication_info_get_qop_options)
    CONCEPT_FUNCTION(osip_authentication_info_set_rspauth)
    CONCEPT_FUNCTION(osip_authentication_info_get_rspauth)
    CONCEPT_FUNCTION(osip_authentication_info_set_nonce_count)
    CONCEPT_FUNCTION(osip_authentication_info_get_nonce_count)

    CONCEPT_FUNCTION(osip_proxy_authorization_set_auth_type)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_auth_type)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_username)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_username)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_realm)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_realm)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_nonce)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_nonce)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_uri)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_uri)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_response)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_response)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_digest)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_digest)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_algorithm)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_algorithm)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_cnonce)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_cnonce)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_opaque)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_opaque)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_message_qop)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_message_qop)
    CONCEPT_FUNCTION(osip_proxy_authorization_set_nonce_count)
    CONCEPT_FUNCTION(osip_proxy_authorization_get_nonce_count)

    CONCEPT_FUNCTION(osip_dialog_init_as_uac)
    CONCEPT_FUNCTION(osip_dialog_init_as_uac_with_remote_request)
    CONCEPT_FUNCTION(osip_dialog_init_as_uas)
    CONCEPT_FUNCTION(osip_dialog_free)
    CONCEPT_FUNCTION(osip_dialog_set_state)
    CONCEPT_FUNCTION(osip_dialog_update_route_set_as_uas)
    CONCEPT_FUNCTION(osip_dialog_update_osip_cseq_as_uas)
    CONCEPT_FUNCTION(osip_dialog_match_as_uac)
    CONCEPT_FUNCTION(osip_dialog_update_tag_as_uac)
    CONCEPT_FUNCTION(osip_dialog_update_route_set_as_uac)
    CONCEPT_FUNCTION(osip_dialog_match_as_uas)
    //CONCEPT_FUNCTION(osip_dialog_is_originator)
    //CONCEPT_FUNCTION(osip_dialog_is_callee)

    CONCEPT_FUNCTION(osip_start_200ok_retransmissions)
    CONCEPT_FUNCTION(osip_start_ack_retransmissions)
    CONCEPT_FUNCTION(osip_stop_200ok_retransmissions)
    CONCEPT_FUNCTION(osip_stop_retransmissions_from_dialog)
    CONCEPT_FUNCTION(osip_new_outgoing_sipmessage)

    CONCEPT_FUNCTION(osip_message_get_header_str)
    CONCEPT_FUNCTION(osip_transaction_describe)
    CONCEPT_FUNCTION(osip_remove_transaction)
}
#endif // __LIBRARY_H
